'FFSubmenu=GPS
'FFName=Geodaten sammeln
'
'(c) Harald Maeckler, Dsseldorf 2016
' ***********************************************************************
' GeoCollection.vbs (Skript fr FixFoto)
' Geodaten sammeln und eintragen
' ***********************************************************************
'
' Version 1.06 vom 17.10.2016	- berprfung auf Gltigkeit der GPS-Daten verbessert
' Version 1.05 vom 11.10.2016	- ber Aufruf 'Google Maps' wird jetzt www.gpskoordinaten.de aufgerufen
'									wo auf Wunsch auch die Hhe ermittelt werden kann
' Version 1.04 vom 20.09.2016	- Geodaten direkt aus Zwischenablage bernehmen,
'									wenn gltige Daten vorhanden
' Version 1.03 vom 04.05.2016	- fehlt bei ausgewhlten jpg-Bildern der
'									Exif-Datenblock wird dieser erzeugt
' Version 1.02 vom 03.05.2016	- weiteren Bug bei Geohhe = "" beseitigt
' Version 1.01 vom 02.05.2016	- Bug bei Geohhe = "" beseitigt
' Version 1.00 vom 22.04.2016	- Betaversion mit ersten Anpassungen
' ***********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.06"
const SkriptURL = "http://www.ffsf.de/resources/geocollection.351/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort,Anzeige,pos,n

'Konstanten und Variable fr das Sortieren
Dim UrListenArray,ListenArray,Ergebnis
const TZ = "*"   'Trennzeichen zur Kennzeichnung von Umlauten

'Spezifische Konstanten und Variable
'const URL_Google = "http://maps.google.de/"
const URL_Google = "http://www.gpskoordinaten.de/"
const URL_Bing = "https://www.bing.com/mapspreview"
Dim AuswahlArray,element
Dim wert_Auswahl,bild_Array,WertListe,Listendatei,Datei,Zeile
Dim GDbreite,GDlaenge,GDhoehe,Geodate,Benennung,Speicherflag,Wert

'Konstanten und Variable zum Zeigen des Geobilds
const Kartentyp = "Karte,Satellit,Hybrid,Gelnde"
Dim Ktyp_Array,K_Typ,Z_Wert

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "GeoCollection"					'Skriptname
const RegSchluessel = "FF_GeoCollection"		'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

AuswahlArray = Array("Aktuelles Bild","Selekt. Bilder Comp.-Verz.","Alle Bilder Comp.-Verz.","Selekt. Bilder akt. Liste","Alle Bilder akt. Liste")
Listendatei = FF_GetScriptPath & "\MeckiScript\GeoCollection\GeoDaten.txt"
Ktyp_Array = split(Kartentyp,",")

'** Start Dialog GeoCollection **
FF_AddDialog "GeoCollection",319,145
FF_AddControl "GeoCollection","Auswahl zum Eintragen","GROUP",5,5,86,25
FF_AddControl "GeoCollection","in GPS-Liste bernehmen aus","GROUP",5,34,86,41
FF_AddControl "GeoCollection","markierten Eintrag in GPS-Liste","GROUP",5,80,86,30
FF_AddControl "GeoCollection","GPS-Liste","GROUP",97,5,216,105
FF_AddControl "GeoCollection","wert_Auswahl","COMBO",10,15,76,10
FF_AddControl "GeoCollection","Google Maps","BUTTON",9,46,38,11
FF_AddControl "GeoCollection","aktuellem Bild","BUTTON",9,60,38,11
FF_AddControl "GeoCollection","Lschen","BUTTON",9,93,38,11
FF_AddControl "GeoCollection","Umbenennen","BUTTON",49,93,38,11
FF_AddControl "GeoCollection","sp_Liste","LISTBOX",104,15,203,81
FF_AddControl "GeoCollection","Doppelklick zeigt den Geopunkt auf einer Karte","STATIC",135,97,135,10
FF_SetControlStyle "GeoCollection","Doppelklick zeigt den Geopunkt auf einer Karte",1
FF_AddControl "GeoCollection","Fortschritt","PROGRESS",5,115,308,4
FF_AddControl "GeoCollection","?","BUTTON",13,127,11,11
FF_AddControl "GeoCollection","|","STATIC",26,127,22,11
FF_SetControlStyle "GeoCollection","|",1
FF_AddControl "GeoCollection","Update","BUTTON",50,127,33,11
FF_AddControl "GeoCollection","Vorgang abbrechen mit","STATIC",101,127,58,11
FF_AddControl "GeoCollection","Backspace","BUTTON",159,128,30,9
FF_AddControl "GeoCollection","- Taste","STATIC",190,127,20,11
FF_AddControl "GeoCollection","Abbrechen","BUTTON",227,127,33,11
FF_AddControl "GeoCollection","Eintragen","BUTTON",271,127,33,11
FF_AddControl "GeoCollection","&delete","BUTTON",0,0,1,1
FF_AddControl "GeoCollection","&zeigen","BUTTON",0,0,1,1
FF_AddControl "GeoCollection","Zwischenabl.","BUTTON",49,60,38,11
FF_AddControl "GeoCollection","Bing Maps","BUTTON",49,46,38,11
'** End Dialog GeoCollection **

for each element in AuswahlArray
	FF_SetControl "GeoCollection","wert_Auswahl",element
next

if objFS.FileExists(Listendatei) then
	Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
	do Until Datei.AtEndOfStream
		Zeile = Datei.ReadLine
		FF_SetControl "GeoCollection","sp_Liste",Zeile
		if len(WertListe) = 0 then
			Wertliste = Zeile
		else
			WertListe = WertListe & vbNewLine & Zeile
		end if
	loop
	Datei.Close
end if

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "GeoCollection","Google Maps", "" &_
						 "'Google Maps Koordinaten' wird aufgerufen" & vbNewLine &_
						 "Dort Koordinaten in die Zwischenablage kopieren" & vbNewLine &_
						 "(Abbruch mit BACKSPACE)"
	FF_SetControlTooltip "GeoCollection","Bing Maps", "" &_
						 "'Bing Maps' wird aufgerufen" & vbNewLine &_
						 "Dort Koordinaten in die Zwischenablage kopieren" & vbNewLine &_
						 "(Abbruch mit BACKSPACE)"
	FF_SetControlTooltip "GeoCollection","aktuellem Bild", "" &_
						 "aus Bild auf der Arbeitsflche" & vbNewLine &_
						 "Geodaten bernehmen und nach" & vbNewLine &_
						 "Bezeichnen in GPS-Liste eintragen"
	FF_SetControlTooltip "GeoCollection","Zwischenabl.", "" &_
						 "in Zwischenablage vorhandene Geodaten bernehmen" & vbNewLine &_
						 "und nach Bezeichnen in GPS-Liste eintragen"
	FF_SetControlTooltip "GeoCollection","Lschen", "" &_
						 "markierte Geodate in der GPS-Liste lschen"
	FF_SetControlTooltip "GeoCollection","Umbenennen", "" &_
						 "markierte Geodate in der GPS-Liste umbenennen"
	FF_SetControlTooltip "GeoCollection","sp_Liste", "" &_
						 "mit Doppelklick auf eine Geodate wird" & vbNewLine &_
						 "diese auf einer Karte angezeigt"
	FF_SetControlTooltip "GeoCollection","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "GeoCollection","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "GeoCollection","Backspace", "" &_
						 "laufende Bearbeitung abbrechen"
	FF_SetControlTooltip "GeoCollection","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "GeoCollection","Eintragen", "" &_
						 "markierte Geodate in die ausgewhlten Bilder eintragen"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 4000
FF_SetDialogTimer "GeoCollection", 100
FF_ActivateControl "GeoCollection","&zeigen"
FF_ActivateControl "GeoCollection","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("GeoCollection")
	Case "TIMER"
		FF_SetControl "GeoCollection" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "GeoCollection", 0
	Case "&zeigen"
		FF_SetControl "GeoCollection","Fortschritt",65	'############## nur fr Screenshot
		FF_SetControl "GeoCollection","|","x.xx"		'############## nur fr Screenshot
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Google Maps"
		if InternetConnection then
			call Werte_auslesen
			FF_TextToClipboard ""
			WshShell.Run URL_Google
			call Uebernahme_Internet
			if not Abbruch then	call Uebernahme
		end if
	Case "Bing Maps"
		if InternetConnection then
			call Werte_auslesen
			FF_TextToClipboard ""
			WshShell.Run URL_Bing
			call Uebernahme_Internet
			if not Abbruch then	call Uebernahme
		end if
	Case "aktuellem Bild"
		call Werte_auslesen
		call Uebernahme_Bild
		if not Abbruch then call Uebernahme
	Case "Zwischenabl."
		Wert = FF_TextFromClipboard
		call CheckGPS
		if not Abbruch then
			call GPS_Daten
			if not Abbruch then
				call Uebernahme
			else
				msgbox "Keine gltigen GPS-Daten vorhanden!",vbInformation,"Information"
			end if
		else
			msgbox "Keine gltigen GPS-Daten vorhanden!",vbInformation,"Information"
		end if
	Case "Lschen"
		call Loeschen
		call Sichern
	Case "Umbenennen"
		call Date_Umbenennen
	Case "Eintragen"
		call Werte_auslesen
		call BildAuswahl
		if not Abbruch then
			call Eintragen
			if not Abbruch then exit do
		end if
	Case "sp_Liste"
		if InternetConnection then
			call Geo_BildDialog
			FF_Reload
		end if
	Case "?"
		Anzeige = chr(34) & FF_GetScriptPath & "\MeckiScript\GeoCollection\GeoCollection.pdf" & chr(34)
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?).",vbInformation,"Hinweis"
			err.clear
		end if
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "Abbrechen","CANCEL"
		call Sichern
		exit do
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("GeoCollection")

if Speicherflag then
	FF_LoadImage FF_GetScriptPath & "\MeckiScript\GeoCollection\geobild.png"
	FF_ImportImage FF_GetScriptPath & "\MeckiScript\GeoCollection\geobild.png"
end if
if SkriptKill then call KillSkript


end sub
'------------------------------------------------------------------------
Sub Sichern

Set Datei = objFS.OpenTextFile(Listendatei, ForWriting, True)
Datei.Write WertListe
Datei.Close

end sub
'------------------------------------------------------------------------
Sub Loeschen
Dim GeoWert,Zeile

GeoWert = FF_GetControl("GeoCollection","sp_Liste")
if len(GeoWert) = 0 then exit sub

FF_SetControl "GeoCollection","sp_Liste",""
Wertliste = ""
if objFS.FileExists(Listendatei) then
	Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
	do Until Datei.AtEndOfStream
		Zeile = Datei.ReadLine
		if Zeile <> GeoWert then
			FF_SetControl "GeoCollection","sp_Liste",Zeile
			if len(WertListe) = 0 then
				Wertliste = Zeile
			else
				WertListe = WertListe & vbNewLine & Zeile
			end if
		end if
	loop
	Datei.Close
end if

end sub
'------------------------------------------------------------------------
Sub Date_Umbenennen
Dim GeoWert,GeoWert_Array

GeoWert = FF_GetControl("GeoCollection","sp_Liste")
if len(GeoWert) = 0 then exit sub

pos = instr(GeoWert,"|")
Benennung = trim(left(Geowert,pos -1))
GeoWert = trim(mid(Geowert,pos +1))
GeoWert_Array = split(GeoWert,",")
GDbreite = GeoWert_Array(0) : GDlaenge = GeoWert_Array(1) : GDhoehe = GeoWert_Array(2)

call Loeschen
call Uebernahme
Benennung = ""

end sub
'------------------------------------------------------------------------
Sub BildAuswahl
Dim typ

'Bild ermitteln
Select Case wert_Auswahl
	Case "Aktuelles Bild"
		typ = 4
	Case "Selekt. Bilder Comp.-Verz."
		typ = 1
	Case "Alle Bilder Comp.-Verz."
		typ = 0
	Case "Selekt. Bilder akt. Liste"
		typ = 3 
	Case "Alle Bilder akt. Liste"
		typ = 2
End Select

if typ = 4 then
	bild_Array = Array(FF_GetImageName(-1))
else
	if len(FF_GetSelection(typ)) > 0 then
		bild_Array = split(FF_GetSelection(typ),vbNewLine)
	end if
end if

if len(bild_Array(0)) = 0 then
	msgbox "Bildauswahl berprfen!",vbInformation,"Hinweis"
	Abbruch = true
end if

end sub
'------------------------------------------------------------------------
Sub Eintragen
Dim GeoWert,GeoWert_Array,Anz,AnzB,msg

GeoWert = FF_GetControl("GeoCollection","sp_Liste")
if len(GeoWert) = 0 then
	msgbox "Es ist keine Geodate vorhanden!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

pos = instr(GeoWert,"|")
GeoWert = trim(mid(Geowert,pos +1))
GeoWert_Array = split(GeoWert,",")

Anz = ubound(bild_Array) +1 : AnzB = 0
For n = 0 to Anz -1
	if FF_IdentifyImage(bild_Array(n)) = 2 then	'nur JPG-Bilder
		FF_LoadImage bild_Array(n)
		if not FF_HasExif then FF_CreateExifInFile bild_Array(n)
		FF_SetExifTag "Latitude",GeoWert_Array(0)
		FF_SetExifTag "Longitude",GeoWert_Array(1)
		FF_SetExifTag "Altitude",GeoWert_Array(2)
		FF_SaveExif(bild_Array(n))
		AnzB = AnzB +1
	end if

	'### Fortschrittsanzeige
	FF_SetControl "GeoCollection","Fortschritt",(n +1)/Anz*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
next

if Anz = 1 then
	msg = "Von einem ausgewhlten Bild" & vbNewLine
else
	msg = "Von " & Anz & " ausgewhlten Bildern" & vbNewLine
end if

if AnzB = 0 then
	msg = msg & "wurde kein Bild bearbeitet!"
else
	msg = msg & "wurden " & AnzB & " Bilder bearbeitet!"
end if

msgbox msg,vbInformation,"Schlussmeldung"

end sub
'------------------------------------------------------------------------
Sub Uebernahme_Bild

'GPS-Daten ermitteln
if len(FF_GetImageName(-1)) > 0 then
	FF_LoadImage FF_GetImageName(-1)
else
	msgbox "Es muss ein Bild geladen sein!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if not FF_HasExif then
	msgbox "Das Bild" & vbNewLine & FF_GetImageName(-1) & vbNewLine & "hat keine Exif-Daten!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if len(FF_GetExifTag("Latitude")) = 0 or len(FF_GetExifTag("Longitude")) = 0 then
	msgbox "Das aktuelle Bild enthlt keine Geodaten!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

GDbreite = FF_GetExifTag("Latitude")
GDlaenge = FF_GetExifTag("Longitude")
GDhoehe = FF_GetExifTag("Altitude")

if IsNumeric(GDhoehe) then
	GDhoehe = Replace(GDhoehe,".",",")
	GDhoehe = Round(GDhoehe,3)
end if

end sub
'------------------------------------------------------------------------
Sub Uebernahme_Internet
Dim x,Start
const Dauer = 90

Start = Timer
do														'### Warten bis Geodate in der Zwischenablage
	if FF_CheckKey() = 8 then
		msgbox "Die Ermittlung der Geodaten wird abgebrochen!",vbInformation,"Hinweis"
		Abbruch = true : exit sub		
	end if
	if Timer - Start > Dauer then
		msgbox "Nach " & Dauer & " sec wurden immer noch" & vbNewLine &_
				"keine Koordinaten in die Zwischenablage kopiert." & vbNewLine & vbNewLine &_
				"Bitte erneut probieren!",vbInformation,"Hinweis"
		Abbruch = true : exit sub
	end if
	Wert = FF_TextFromClipboard
	if len(Wert) > 0 then exit do
	FF_Sleep 100
loop

call CheckGPS
if Abbruch then
	msgbox "Der Wert " & chr(34) & Wert & chr(34) & vbNewLine & "ist keine gltige Geodate!",vbInformation,"Hinweis"
	exit sub
end if

call GPS_Daten
if Abbruch then
	msgbox "Der Wert " & chr(34) & Wert & chr(34) & vbNewLine & "ist keine gltige Geodate!",vbInformation,"Hinweis"
	exit sub
end if

end sub
'------------------------------------------------------------------------
Sub CheckGPS
'Prfen ob eine GPS-Date vorliegt

if instr(Wert,"Breitengrad :") > 0 and instr(Wert,"Lngengrad :") > 0 then exit sub	'http://www.gpskoordinaten.de/

if len(Wert) > 7 and (instr(Wert,",") > 0 or instr(Wert,"") > 0) then
	if instr(left(Wert,4),",") > 0 then		'Ersatz der Kommata durch Punkte bei BING-Seite
		Wert = replace(Wert,",",".",1,1)
		pos = instrRev(Wert,",")
		Wert = left(Wert,pos-1) & replace(Wert,",",".",pos,1)
	end if
else
	Abbruch = true
end if

end sub
'------------------------------------------------------------------------
Sub GPS_Daten
'Breite, Lnge, Hhe bestimmen
Dim ArrayW,ArrayWGPS_Date

if instr(Wert,"Breite") > 0 and instr(Wert,"Lnge") > 0 then
	Wert = replace(Wert,":"," ")
	Wert = replace(Wert,vbNewLine," ")
	Wert = Wert & " "
	
	GDbreite = decimal2grad (Koordinate("Breite"),true)
	GDlaenge = decimal2grad (Koordinate("Lnge"),false)
	GDhoehe = Koordinate("Hhe")
	
	exit sub
end if

ArrayW = split(Wert,",")
if instr(Wert,"") > 0 then			'GPS-Daten liegen als Gradwerte vor
	x = instr(Wert,chr(34))
	GDbreite = Formatierung(left(Wert,x +1))
	GDlaenge = Formatierung(mid(Wert,x +3))
else								'GPS-Daten liegen als Dezimalwerte vor
	'Wandlung Dezimal zu Grad
	ArrayWGPS_Date = split(Wert,",")
	GDbreite = decimal2grad (ArrayW(0),true)
	GDlaenge = decimal2grad (ArrayW(1),false)
end if
GDhoehe = ""

end sub
'------------------------------------------------------------------------
function Koordinate (KoArt)
Dim Zwert

pos = instr(Wert,KoArt)
if pos = 0 then Koordinate = "" : exit Function

Zwert = mid(Wert,pos)
pos = instr(Zwert," ")
Zwert = ltrim(mid(Zwert,pos))
pos = instr(Zwert," ")
Koordinate = trim(left(Zwert,pos))

end function
'------------------------------------------------------------------------
Sub Uebernahme
Dim Bezeichnung

GeoDate = GDbreite & "," & GDlaenge & "," & GDhoehe

do
	if len(GDhoehe) > 0 then
		Bezeichnung = InputBox("Benennung der Koordinaten" & vbNewLine & GDbreite & vbNewLine & GDlaenge & vbNewLine & GDhoehe & " m","Geodate",Benennung)
	else
		Bezeichnung = InputBox("Benennung der Koordinaten" & vbNewLine & GDbreite & vbNewLine & GDlaenge,"Geodate",Benennung)
	end if
	'Bezeichnung = ucase(Bezeichnung)
	if len(Bezeichnung) = 0 then
		if len(Benennung) > 0 then
			Bezeichnung = Benennung
			exit do
		else
			exit sub
		end if
	end if
	if instr(Bezeichnung,"|") > 0 or instr(Bezeichnung,TZ) > 0 then
		msgbox "Die Zeichen | und " & TZ & vbNewLine & "sind nicht zugelassen!",vbInformation,"Hinweis"
	else
		exit do
	end if
loop

if len(WertListe) = 0 then
	Wertliste = Bezeichnung & " | " & GeoDate
else
	Wertliste = WertListe & vbNewLine & Bezeichnung & " | " & GeoDate
end if

'### Sortieren
call Vorbereitung
if not Abbruch then
 	call QuickSort(ListenArray,"","")
 	call Rekonstruktion
end if
'### Sortieren Ende

FF_SetControl "GeoCollection","sp_Liste",""
for each element in ListenArray
	FF_SetControl "GeoCollection","sp_Liste",element
next

WertListe = join(ListenArray,vbNewLine)
call Sichern

'in GPS-Liste markieren
FF_SetControl "GeoCollection","sp_Liste",Bezeichnung & " | " & GeoDate

end sub
'------------------------------------------------------------------------
Sub GeoBildZeigen
Dim GeoWert_Array
Dim url,Kartentyp,Koordinaten,Zoom,GeoWert

const Dimension = "&size=640x640"
const Markercolor = "&markers=color:red|"
const Markersize = "size:normal|"
const Markerlabel = "label:|"

		Select Case K_Typ
			Case "Karte"
				Kartentyp = "&maptype=raodmap"
			Case "Satellit"
				Kartentyp = "&maptype=satellite"
			Case "Hybrid"
				Kartentyp = "&maptype=hybrid"
			Case "Gelnde"
				Kartentyp = "&maptype=terrain"
		End Select
		
		Zoom = "&zoom=" & Z_Wert

GeoWert = FF_GetControl("GeoCollection","sp_Liste")
if len(GeoWert) = 0 then exit sub
pos = instr(GeoWert,"|")
GeoWert = trim(mid(Geowert,pos +1))
GeoWert_Array = split(GeoWert,",")
Koordinaten = grad2decimal(GeoWert_Array(0)) & "," & grad2decimal(GeoWert_Array(1)) & "|"


url = "http://maps.google.com/maps/api/staticmap?" & Dimension & Kartentyp & Markercolor & Markersize & Markerlabel &_
													 Koordinaten & Zoom & "&sensor=false"
FF_LoadURL url, FF_GetScriptPath & "\MeckiScript\GeoCollection\geobild.png"

end sub
'------------------------------------------------------------------------
Sub Geo_BildDialog

'** Start Dialog Karte mit Geopunkt **
FF_AddDialog "Karte mit Geopunkt",290,305
FF_AddControl "Karte mit Geopunkt","Gbild_Gross","IMAGE",5,5,280,280
FF_AddControl "Karte mit Geopunkt","Typ","STATIC",5,290,11,11
FF_AddControl "Karte mit Geopunkt","K_Typ","COMBO",17,290,33,10
FF_AddControl "Karte mit Geopunkt","Zoom","STATIC",54,290,15,11
FF_AddControl "Karte mit Geopunkt","Z_Wert","COMBO",69,290,19,10
FF_AddControl "Karte mit Geopunkt","|","STATIC",90,290,199,11
FF_SetControlStyle "Karte mit Geopunkt","|",1
FF_AddControl "Karte mit Geopunkt","&speichern","BUTTON",0,0,1,1
'** End Dialog Karte mit Geopunkt **

Ktyp_Array = split(Kartentyp,",")
for each element in Ktyp_Array
	FF_SetControl "Karte mit Geopunkt","K_Typ",element
next
FF_SetControl "Karte mit Geopunkt","K_Typ",K_Typ

for element = 1 to 20
	FF_SetControl "Karte mit Geopunkt","Z_Wert",element
next
FF_SetControl "Karte mit Geopunkt","Z_Wert",Z_Wert

call GeoBildZeigen
FF_SetControl "Karte mit Geopunkt","Gbild_Gross",FF_GetScriptPath & "\MeckiScript\GeoCollection\geobild.png"
Speicherflag = false

FF_SetDialogTimer "Karte mit Geopunkt", 100
FF_ActivateControl "Karte mit Geopunkt","&speichern"
do
	Select Case FF_ShowDialog ("Karte mit Geopunkt")
	Case "TIMER"
		FF_SetControl "Karte mit Geopunkt" ,"|", FF_GetControl("GeoCollection","sp_Liste")
		FF_SetDialogTimer "Karte mit Geopunkt", 0
	Case "&speichern"
		Speicherflag = true
	Case "K_Typ","Z_Wert"
		K_Typ = FF_GetControl("Karte mit Geopunkt","K_Typ")
		Z_Wert = FF_GetControl("Karte mit Geopunkt","Z_Wert")
		call GeoBildZeigen
		FF_SetControl "Karte mit Geopunkt","Gbild_Gross",FF_GetScriptPath & "\MeckiScript\GeoCollection\geobild.png"
	Case "CANCEL"
		exit do
	End Select
loop

K_Typ = FF_GetControl("Karte mit Geopunkt","K_Typ")
Z_Wert = FF_GetControl("Karte mit Geopunkt","Z_Wert")

FF_CloseDialog ("Karte mit Geopunkt")

end sub
'------------------------------------------------------------------------
Sub Werte_auslesen

'Auswahl
wert_Auswahl = FF_GetControl ("GeoCollection","wert_Auswahl")

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Auswahl
wert_Auswahl = FF_GetProfile (RegSchluessel,"wert_Auswahl")
if wert_Auswahl = "" then wert_Auswahl = "Aktuelles Bild"

'Geobild
K_Typ = FF_GetProfile (RegSchluessel,"K_Typ")
if K_Typ ="" then K_Typ = "Karte"
Z_Wert = FF_GetProfile (RegSchluessel,"Z_Wert")
if Z_Wert ="" then Z_Wert = "16"

'### Werte eintragen

'Auswahl
FF_SetControl "GeoCollection","wert_Auswahl",wert_Auswahl

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"wert_Auswahl",wert_Auswahl
FF_WriteProfile RegSchluessel,"K_Typ",K_Typ
FF_WriteProfile RegSchluessel,"Z_Wert",Z_Wert

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\GeoCollection"					'Ordner
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
'************************************************************************
'Sortieren
'************************************************************************
'------------------------------------------------------------------------
Sub Vorbereitung
Dim UL,ULn

UrListenArray = split(Wertliste,vbNewLine) 'Sicherung des Ursprungs
ListenArray = split(Wertliste,vbNewLine)
 
'### Umlautkorrektur fr das erste Zeichen
for n = 0 to UBound(ListenArray)
   UL = left(ListenArray(n),1)
   if instr("",UL) > 0 then
      select case UL
         case "","" : ULn = "Ae"
         case "","" : ULn = "Oe"
         case "","" : ULn = "Ue"
      case else
      end select
      ListenArray(n) = ULn & mid(ListenArray(n),2) & TZ & UL
   end if
 
   '### String in Grobuchstaben umwandeln
   ListenArray(n) = ucase(ListenArray(n))
next
 
End Sub
'------------------------------------------------------------------------
Sub Rekonstruktion
 
'### Umlaute wieder zurck setzen
for n = 0 to UBound(ListenArray)
   pos = instr(ListenArray(n),TZ)
   if pos > 0 then
      ListenArray(n) = right(ListenArray(n),1) & mid(ListenArray(n),3,pos-3)
   end if
 
   '### ursprngliche Gro- und Kleinschreibung wieder herstellen
   for each element in UrListenArray
      if ListenArray(n) = ucase(element) then ListenArray(n) = element :   exit for
   next
next
 
End Sub
'------------------------------------------------------------------------
Sub QuickSort(vSort,ByVal lngStart,ByVal lngEnd)
'### Sortieren des Arrays 'vSort' nach ASCII-Werten

Dim i,j,h,x
 
if lngStart = "" then lngStart = 0
if lngEnd = "" then lngEnd = ubound(vSort)
 
i = lngStart : j = lngEnd
x = vSort((lngStart + lngEnd) / 2)
 
'# Array aufteilen
Do
   While (vSort(i) < x): i = i + 1: Wend
   While (vSort(j) > x): j = j - 1: Wend
 
   If (i <= j) Then
      '# Wertepaare miteinander tauschen
      h = vSort(i)
      vSort(i) = vSort(j)
      vSort(j) = h
      i = i + 1: j = j - 1
   End If
Loop Until (i > j)
 
'# Rekursion
If (lngStart < j) Then call QuickSort(vSort,lngStart,j)
If (i < lngEnd) Then call QuickSort(vSort,i,lngEnd)
 
End Sub
'------------------------------------------------------------------------
'************************************************************************
'Dezimal- zu Gradzahl
'************************************************************************
'------------------------------------------------------------------------
Function decimal2grad (ByVal dezkoord, breite)
'dezimale Angaben werden in Gradangaben gewandelt
'* erwartet wird die Dezimalkoordinate und
'* True fr Breitengrad bzw. False fr Lngengrad

Dim Richtung,Grad,Minuten,Sekunden

on error resume next

	if breite = true Then     ' Breite
		'westliche Breite und sdliche Lnge haben negativ Dezimalkoordinaten
		if InStr(dezkoord,"-") > 0 Then
			Richtung = "S"
		Else
			Richtung = "N"
		End If
	Else                    ' Lnge
		if InStr(dezkoord,"-") > 0 Then
			Richtung = "W"
		Else
			Richtung = "E"
		End If
	End If
	
	dezkoord = Replace(dezkoord,".",",")    ' wegen Zahlenformat Punkt durch Komma ersetzen
	Grad = Abs(Fix(dezkoord))        		' pos. Ganzzahl ermitteln
	Minuten = (Abs(dezkoord)-Grad)*60
	Sekunden = (Minuten - Fix(Minuten)) * 60
	Minuten = Fix(Minuten)
	
	decimal2grad = Richtung & " " & FormatNumber(Grad,2) & " " & FormatNumber(Minuten,2) & "' " &  FormatNumber(Round(Sekunden,2),2) & Chr(34)
	decimal2grad = Replace(decimal2grad,",",".")

if err <> 0 then Abbruch = true
on error goto 0

End Function
'-----------------------------------------------------------------------
'***********************************************************************
'* Grad- zu Dezimalzahl
'***********************************************************************
function grad2decimal(ByVal p_Str)
	dim l_Richtung
	dim l_Pos
	dim l_Wert

on error resume next

	if p_Str<>"" then
		p_Str=replace(p_Str,".",",",1)
		l_Richtung=left(p_Str,1)
		p_Str=ltrim(right(p_Str,len(p_Str)-1))
		l_Pos=instr(p_Str,"")
		'msgbox l_Wert
		l_Wert=1.0*(left(p_Str,l_Pos-1))
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"'")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/60
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"""")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/3600
		Select Case l_Richtung
			Case "s", "S", "w", "W"
				grad2decimal="-" & replace(FormatNumber(l_Wert,6),",",".",1)
			case Else
				grad2decimal=replace(FormatNumber(l_Wert,6),",",".",1)
		End Select
	else
		grad2decimal=""
	end if

if err <> 0 then Abbruch = true
on error goto 0

end function
'-----------------------------------------------------------------------
